---
title: Using the W3C DOM Level 1 Core
slug: Web/API/Document_object_model/Using_the_W3C_DOM_Level_1_Core
tags:
  - DOM
  - NeedsUpdate
---
<div>{{DefaultAPISidebar("DOM")}}</div>

<p>The W3C's <a href="https://www.w3.org/TR/REC-DOM-Level-1/level-one-core.html">DOM Level 1 Core</a> is an API for manipulating the DOM trees of HTML and XML documents (among other tree-like types of documents). Due to the ubiquity of the DOM, this API is supported in all major browsers, including Mozilla Firefox and Microsoft Internet Explorer, and serves as a base for scripting on the web.</p>

<h2 id="What_is_a_content_tree.3F">What is a DOM tree?</h2>

<p>A <a href="https://www.w3.org/TR/REC-DOM-Level-1/introduction.html">DOM</a> tree is a kind of <a href="https://en.wikipedia.org/wiki/Tree_structure">tree</a> whose nodes represent an HTML or XML document's contents. Each HTML or XML document has a unique DOM tree representation. For example, the following document</p>

<pre class="brush: html notranslate">&lt;html&gt;
&lt;head&gt;
  &lt;title&gt;My Document&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
  &lt;h1&gt;Header&lt;/h1&gt;
  &lt;p&gt;Paragraph&lt;/p&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>

<p>has a DOM tree that looks like this:</p>

<p><img alt="image:Using_the_W3C_DOM_Level_1_Core-doctree.jpg" class="internal" src="/@api/deki/files/415/=Using_the_W3C_DOM_Level_1_Core-doctree.jpg"></p>

<p>(Note that, although the above tree is similar to the above document's DOM tree, it's not identical, as <a href="/en-US/docs/Web/API/Document_Object_Model/Whitespace_in_the_DOM">the actual DOM tree preserves whitespace</a>.)</p>

<p>When a web browser parses an HTML document, it builds a DOM tree and then uses it to display the document.</p>

<h2 id="What_does_the_DOM_Level_1_Core_let_me_do.3F">What does the DOM Level 1 Core let me do?</h2>

<p>The W3C DOM Level 1 Core allows you to change a DOM tree in <em>any way you want</em>. This implies the ability to create any HTML or XML document from scratch, or to change any contents of a given HTML or XML document. The easiest way for web page authors to edit the DOM of a document is to use JavaScript to access the <code>document</code> property of the global object. This <code>document</code> object implements the <a class="external" href="http://www.w3.org/TR/REC-DOM-Level-1/level-one-core.html#i-Document">Document interface</a> from the W3C's DOM Level 1 spec.</p>

<h2 id="A_simple_example">A simple example</h2>

<p>Suppose the author wants to change the header of the above document and write two paragraphs instead of one. The following script would do the job:</p>

<h3 id="HTML_Content">HTML Content</h3>

<pre class="brush: html notranslate">&lt;body&gt;
&lt;input type="button" value="Change this document." onclick="change()"&gt;
&lt;h2&gt;Header&lt;/h2&gt;
&lt;p&gt;Paragraph&lt;/p&gt;
&lt;/body&gt;<span>
</span></pre>

<h3 id="JavaScript_Content">JavaScript Content</h3>

<pre class="brush: js notranslate"><span>  function change() {
    // document.getElementsByTagName("H2") returns a NodeList of the &lt;h2&gt;
    // elements in the document, and the first is number 0:

    var header = document.getElementsByTagName("H2").item(0);
    // the firstChild of the header is a Text node:
    header.firstChild.data = "A dynamic document";
    // now the header is "A dynamic document".

    var para = document.getElementsByTagName("P").item(0);
    para.firstChild.data = "This is the first paragraph.";

    // create a new Text node for the second paragraph
    var newText = document.createTextNode("This is the second paragraph.");
    // create a new Element to be the second paragraph
    var newElement = document.createElement("P");
    // put the text in the paragraph
    newElement.appendChild(newText);
    // and put the paragraph on the end of the document by appending it to
    // the BODY (which is the parent of para)
    para.parentNode.appendChild(newElement);
  }</span></pre>

<p>{{ EmbedLiveSample('A_simple_example', 800, 300) }}</p>

<p>You can see this script as <a class="internal" href="/@api/deki/files/2866/=example.html">a complete example</a>.</p>

<h2 id="How_can_I_learn_more.3F">How can I learn more?</h2>

<p>Now that you are familiar with the basic concepts of the DOM, you may want to learn about the <a href="/en-US/docs/Traversing_an_HTML_table_with_JavaScript_and_DOM_Interfaces">DOM Level 1 fundamental methods</a>.</p>

<p>See also the <a class="external" href="http://www.w3.org/TR/REC-DOM-Level-1/level-one-core.html">DOM Level 1 Core specification</a> from the W3C. It's a reasonably clear spec, although it is formal. The main thing that's useful to authors is the description of the different DOM objects and all their properties and methods. Also see our <a href="/en-US/docs/Web/API/Document_Object_Model">other DOM documentation</a>.</p>

<div class="originaldocinfo">
<p><strong>Original Document Information</strong></p>

<ul>
 <li>Author(s): L. David Baron &lt;dbaron at dbaron dot org&gt;</li>
 <li>Copyright Information: © 1998-2005 by individual mozilla.org contributors; content available under a <a class="external" href="http://www.mozilla.org/foundation/licensing/website-content.html">Creative Commons license</a></li>
</ul>
</div>
